// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#pragma once

#include <functional>
#include <string>

namespace verifone_sdk {

enum class AuthorizationResult : int {
    /** The payment was approved */
    AUTHORIZED,
    /** The payment was rejected */
    DECLINED,
    /** The user cancelled the payment */
    USER_CANCELLED,
    /** The payment was cancelled externally */
    CANCELLED_EXTERNALLY,
    /**
     * The payment was approved using a manual, external method,
     * such as approving over the phone.
     */
    AUTHORIZED_EXTERNALLY,
    /** Used when paid by cash */
    CASH_VERIFIED,
    /**
     * This represents a payment that was voided. Use {@link #getReferencePaymentId()} to get the
     * original payment ID.
     */
    VOIDED,
    /** The reference payment could not be voided. */
    VOID_DECLINED,
    /**
     * This represents a payment that was refunded. Use {@link #getReferencePaymentId()} to get
     * the original payment ID.
     */
    REFUNDED,
    /** The reference payment could not be refunded. */
    REFUND_DECLINED,
    /** For some payment types, the final status will need to be obtained at a later time */
    IN_PROGRESS,
};

constexpr std::string_view toString(const AuthorizationResult& arg) {
    switch(arg) {
        case AuthorizationResult::AUTHORIZED: return "AUTHORIZED";
        case AuthorizationResult::DECLINED: return "DECLINED";
        case AuthorizationResult::USER_CANCELLED: return "USER_CANCELLED";
        case AuthorizationResult::CANCELLED_EXTERNALLY: return "CANCELLED_EXTERNALLY";
        case AuthorizationResult::AUTHORIZED_EXTERNALLY: return "AUTHORIZED_EXTERNALLY";
        case AuthorizationResult::CASH_VERIFIED: return "CASH_VERIFIED";
        case AuthorizationResult::VOIDED: return "VOIDED";
        case AuthorizationResult::VOID_DECLINED: return "VOID_DECLINED";
        case AuthorizationResult::REFUNDED: return "REFUNDED";
        case AuthorizationResult::REFUND_DECLINED: return "REFUND_DECLINED";
        case AuthorizationResult::IN_PROGRESS: return "IN_PROGRESS";
        default: return "AuthorizationResult enum value not supported";
    }
}

}  // namespace verifone_sdk

namespace std {

template <>
struct hash<::verifone_sdk::AuthorizationResult> {
    size_t operator()(::verifone_sdk::AuthorizationResult type) const {
        return std::hash<int>()(static_cast<int>(type));
    }
};

}  // namespace std
